Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -3292,8 +3518,7 @@ static Image *ReadOneJNGImage(MngInfo *m
                   image->page.y/=10000;
                 }
             }
-          if (length)
-            MagickFreeMemory(chunk);
+          MagickFreeMemory(chunk);
           continue;
         }
 
@@ -3318,14 +3543,12 @@ static Image *ReadOneJNGImage(MngInfo *m
       if (!memcmp(type,mng_iCCP,4))
         {
           /* To do. */
-          if (length)
-            MagickFreeMemory(chunk);
+          MagickFreeMemory(chunk);
           continue;
         }
 #endif
 
-      if (length)
-        MagickFreeMemory(chunk);
+      MagickFreeMemory(chunk);
 
       if (memcmp(type,mng_IEND,4))
         continue;
@@ -3356,176 +3579,193 @@ static Image *ReadOneJNGImage(MngInfo *m
     o destroy the secondary image.
   */
 
-  CloseBlob(color_image);
-  if (logging)
-    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                          "    Reading jng_image from color_blob.");
-
-  FormatString(color_image_info->filename,"%.1024s",color_image->filename);
-
-  color_image_info->ping=MagickFalse;   /* To do: avoid this */
-  jng_image=ReadImage(color_image_info,exception);
-  (void) LiberateUniqueFileResource(color_image->filename);
-  DestroyImage(color_image);
-  color_image = (Image *)NULL;
-  DestroyImageInfo(color_image_info);
-  color_image_info = (ImageInfo *)NULL;
-
-  if (jng_image == (Image *) NULL)
+  if (color_image_info == (ImageInfo *) NULL || color_image == (Image *) NULL)
     {
-      /*
-        Don't throw exception here since ReadImage() will already have thrown it.
-      */
-      DestroyImage(image);
+      DestroyImage(color_image);
+      color_image=(Image *) NULL;
       return (Image *) NULL;
     }
 
-  if (logging)
-    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                          "    Copying jng_image pixels to main image.");
-  image->rows=jng_height;
-  image->columns=jng_width;
-  length=MagickArraySize(image->columns,sizeof(PixelPacket));
-  if (jng_height == 0 || jng_width == 0)
+  else
     {
+      CloseBlob(color_image);
       if (logging)
-      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-          "    jng_width=%lu jng_height=%lu",
-          (unsigned long)jng_width,(unsigned long)jng_height);
-      DestroyJNG(NULL,&color_image,&color_image_info,
-        &alpha_image,&alpha_image_info);
-      DestroyImage(jng_image);
-      return ((Image *)NULL);     
-    }
+        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+            "    Reading jng_image from color_blob.");
+
+      FormatString(color_image_info->filename,"%.1024s",color_image->filename);
+
+      color_image_info->ping=MagickFalse;   /* To do: avoid this */
+      jng_image=ReadImage(color_image_info,exception);
+      (void) LiberateUniqueFileResource(color_image->filename);
+      DestroyImage(color_image);
+      color_image = (Image *)NULL;
+      DestroyImageInfo(color_image_info);
+      color_image_info = (ImageInfo *)NULL;
+
+      if (jng_image == (Image *) NULL)
+        {
+          /*
+            Don't throw exception here since ReadImage() will already
+            have thrown it.
+          */
+          DestroyJNG(/*chunk*/ NULL,&color_image,&color_image_info,
+                     &alpha_image,&alpha_image_info);
+          return (Image *) NULL;
+        }
 
-  for (y=0; y < (long) image->rows; y++)
-    {
-      s=AcquireImagePixels(jng_image,0,y,image->columns,1,&image->exception);
-      q=SetImagePixels(image,0,y,image->columns,1);
-      if ((s == (const PixelPacket *) NULL) || (q == (PixelPacket *) NULL))
-        break;
-      (void) memcpy(q,s,length);
-      if (!SyncImagePixels(image))
-        break;
-    }
-  DestroyImage(jng_image);
-  if ((unsigned long) y != image->rows)
-    {
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "Failed to transfer JPEG scanlines");
-      return ((Image *)NULL);
-    }
-
-  if (!image_info->ping)
-    {
-      if (jng_color_type >= 12)
+            "    Copying jng_image pixels to main image.");
+      image->rows=jng_height;
+      image->columns=jng_width;
+      length=MagickArraySize(image->columns,sizeof(PixelPacket));
+      if (jng_height == 0 || jng_width == 0 || length == 0)
+        {
+          if (logging)
+          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+              "    jng_width=%lu jng_height=%lu",
+              (unsigned long)jng_width,(unsigned long)jng_height);
+          DestroyJNG(NULL,&color_image,&color_image_info,
+            &alpha_image,&alpha_image_info);
+          DestroyImage(jng_image);
+          ThrowException(exception,CorruptImageError,
+                         ImproperImageHeader,image->filename);
+          return ((Image *)NULL);
+        }
+      for (y=0; y < (long) image->rows; y++)
+        {
+          s=AcquireImagePixels(jng_image,0,y,image->columns,1,
+             exception);
+          q=SetImagePixels(image,0,y,image->columns,1);
+          if ((s == (const PixelPacket *) NULL) ||
+              (q == (PixelPacket *) NULL))
+            break;
+          (void) memcpy(q,s,length);
+          if (!SyncImagePixels(image))
+            break;
+        }
+      DestroyImage(jng_image);
+      jng_image = (Image *)NULL;
+      if ((unsigned long) y != image->rows)
         {
-          if (jng_alpha_compression_method == 0)
-            {
-              png_byte
-                data[5];
-              (void) WriteBlobMSBULong(alpha_image,0x00000000L);
-              PNGType(data,mng_IEND);
-              LogPNGChunk(logging,mng_IEND,0L);
-              (void) WriteBlob(alpha_image,4,(char *) data);
-              (void) WriteBlobMSBULong(alpha_image,crc32(0,data,4));
-            }
-          CloseBlob(alpha_image);
           if (logging)
             (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "    Reading opacity from alpha_blob.");
+                                  "Failed to transfer JPEG scanlines");
+          DestroyJNG(NULL,&color_image,&color_image_info,
+                     &alpha_image,&alpha_image_info);
+          return ((Image *)NULL);
+        }
+      if (alpha_image != (Image *)NULL && !image_info->ping)
+        {
+          if (jng_color_type >= 12)
+            {
+              if (jng_alpha_compression_method == 0)
+                {
+                  png_byte
+                    data[5];
+                  (void) WriteBlobMSBULong(alpha_image,0x00000000L);
+                  PNGType(data,mng_IEND);
+                  LogPNGChunk(logging,mng_IEND,0L);
+                  (void) WriteBlob(alpha_image,4,(char *) data);
+                  (void) WriteBlobMSBULong(alpha_image,crc32(0,data,4));
+                }
+              CloseBlob(alpha_image);
+              if (logging)
+                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                     "    Reading opacity from alpha_blob.");
 
-          FormatString(alpha_image_info->filename,"%.1024s",
-                       alpha_image->filename);
+              FormatString(alpha_image_info->filename,"%.1024s",
+                           alpha_image->filename);
 
-          jng_image=ReadImage(alpha_image_info,exception);
+              jng_image=ReadImage(alpha_image_info,exception);
 
-          if (jng_image == (Image *)NULL)
-            {
-              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                   "    jng_image is NULL.");
-              DestroyJNG(NULL,&color_image,&color_image_info,
-                &alpha_image,&alpha_image_info);
-            }
-          else
-            {
-              if (logging)
+              if (jng_image == (Image *)NULL)
                 {
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                       "    Read jng_image.");
-                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                       "      jng_image->width=%lu, jng_image->height=%lu",
-                       (unsigned long)jng_width,(unsigned long)jng_height);
-                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                       "      image->rows=%lu, image->columns=%lu",
-                      (unsigned long)image->rows,
-                      (unsigned long)image->columns);
-                }
- 
-              for (y=0; y < (long) image->rows; y++)
-                {
-                  s=AcquireImagePixels(jng_image,0,y,image->columns,1,
-                                       &image->exception);
-                  if (image->matte)
-                    {
-                      q=SetImagePixels(image,0,y,image->columns,1);
-                      for (x=(long) image->columns; x > 0; x--,q++,s++)
-                        q->opacity=(Quantum) MaxRGB-s->red;
-                    }
-                  else
-                    {
-                      q=SetImagePixels(image,0,y,image->columns,1);
-                      for (x=(long) image->columns; x > 0; x--,q++,s++)
-                        {
-                          q->opacity=(Quantum) MaxRGB-s->red;
-                          if (q->opacity != OpaqueOpacity)
-                            image->matte=MagickTrue;
-                        }
-                    }
-                  if (!SyncImagePixels(image))
-                    break;
-                }
-              (void) LiberateUniqueFileResource(alpha_image->filename);
-              DestroyJNG(NULL,&color_image,&color_image_info,
-                &alpha_image,&alpha_image_info);
-              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                  " Destroy the JNG image");
-              DestroyImage(jng_image);
-              jng_image = (Image *)NULL;
+                       "    jng_image is NULL.");
+                  DestroyJNG(NULL,&color_image,&color_image_info,
+                    &alpha_image,&alpha_image_info);
+                }
+             else
+                {
+
+                 if (logging)
+                   {
+                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                          "    Read jng_image.");
+                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                          "      jng_image->width=%lu, jng_image->height=%lu",
+                          (unsigned long)jng_width,(unsigned long)jng_height);
+                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                          "      image->rows=%lu, image->columns=%lu",
+                         (unsigned long)image->rows,
+                         (unsigned long)image->columns);
+                   }
+
+                 for (y=0; y < (long) image->rows; y++)
+                   {
+                     s=AcquireImagePixels(jng_image,0,y,image->columns,1,
+                                          &image->exception);
+                     if (s == (PixelPacket *) NULL)
+                       break;
+                     if (image->matte)
+                       {
+                         q=SetImagePixels(image,0,y,image->columns,1);
+                         if (q == (PixelPacket *) NULL)
+                           break;
+                         for (x=(long) image->columns; x > 0; x--,q++,s++)
+                           q->opacity=(Quantum) MaxRGB-s->red;
+                       }
+                     else
+                       {
+                         q=SetImagePixels(image,0,y,image->columns,1);
+                         if (q == (PixelPacket *) NULL)
+                           break;
+                         for (x=(long) image->columns; x > 0; x--,q++,s++)
+                           {
+                             q->opacity=(Quantum) MaxRGB-s->red;
+                             if (q->opacity != OpaqueOpacity)
+                               image->matte=MagickTrue;
+                           }
+                       }
+                     if (!SyncImagePixels(image))
+                       break;
+                   }
+                 (void) LiberateUniqueFileResource(alpha_image->filename);
+                 DestroyJNG(NULL,&color_image,&color_image_info,
+                   &alpha_image,&alpha_image_info);
+                 (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                     " Destroy the JNG image");
+                 DestroyImage(jng_image);
+                 jng_image = (Image *)NULL;
+               }
             }
-
-          (void) LiberateUniqueFileResource(alpha_image->filename);
-          DestroyJNG(NULL,color_image,color_image_info,
-                     alpha_image,alpha_image_info);
-          DestroyImage(jng_image);
-          jng_image = (Image *)NULL;
         }
+
+      /*
+        Read the JNG image.
+      */
+      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+          " Read the JNG image");
+      image->page.width=jng_width;
+      image->page.height=jng_height;
+      image->page.x=mng_info->x_off[mng_info->object_id];
+      image->page.y=mng_info->y_off[mng_info->object_id];
+      mng_info->image_found++;
+      (void) MagickMonitor(LoadImagesTag,2*GetBlobSize(image),2*GetBlobSize(image),exception);
     }
 
-  /*
-    Read the JNG image.
-  */
-  image->page.width=jng_width;
-  image->page.height=jng_height;
-  image->page.x=mng_info->x_off[mng_info->object_id];
-  image->page.y=mng_info->y_off[mng_info->object_id];
-  mng_info->image_found++;
-  (void) MagickMonitor(LoadImagesTag,2*GetBlobSize(image),2*GetBlobSize(image),
-                       exception);
+  /* Clean up in case we didn't earlier */
 
-  DestroyJNG(NULL,color_image,color_image_info,
-             alpha_image,alpha_image_info);
+  DestroyJNG(NULL,&color_image,&color_image_info,
+    &alpha_image,&alpha_image_info);
 
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "  exit ReadOneJNGImage()");
 
-  SetMagickResourceLimit(PixelsResource,pixels_resource);
-
-  if (image != (Image *)NULL)
-    DestroyImageList(image);
-  return((Image *)NULL);
+  return (image);
 }
 
 /*
@@ -3563,7 +3803,8 @@ static Image *ReadOneJNGImage(MngInfo *m
 %
 */
 
-static Image *ReadJNGImage(const ImageInfo *image_info,ExceptionInfo *exception)
+static Image *ReadJNGImage(const ImageInfo *image_info,
+                           ExceptionInfo *exception)
 {
   Image
     *image;
@@ -3592,55 +3833,97 @@ static Image *ReadJNGImage(const ImageIn
   image=AllocateImage(image_info);
   mng_info=(MngInfo *) NULL;
   status=OpenBlob(image_info,image,ReadBinaryBlobMode,exception);
-  if (status == False)
-    ThrowReaderException(FileOpenError,UnableToOpenFile,image);
+  if (status == MagickFalse)
+  {
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),"Unable to open file");
+    ThrowException(exception,FileOpenError,UnableToOpenFile,image->filename);
+    DestroyImageList(image);
+    image=(Image *) NULL;
+    return ((Image *)NULL);
+  }
   if (LocaleCompare(image_info->magick,"JNG") != 0)
-    ThrowReaderException(CorruptImageError,ImproperImageHeader,image);
+  {
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),"Improper Image Header");
+    ThrowException(exception,CorruptImageError,ImproperImageHeader,image->filename);
+    DestroyImageList(image);
+    image=(Image *) NULL;
+    return((Image *)NULL);
+  }
   /*
     Verify JNG signature.
   */
-  (void) ReadBlob(image,8,magic_number);
-  if (memcmp(magic_number,"\213JNG\r\n\032\n",8) != 0)
-    ThrowReaderException(CorruptImageError,ImproperImageHeader,image);
+  if ((ReadBlob(image,8,magic_number) != 8) ||
+      (memcmp(magic_number,"\213JNG\r\n\032\n",8) != 0))
+  {
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),"Improper Image Header");
+    ThrowException(exception,CorruptImageError,ImproperImageHeader,image->filename);
+    DestroyImageList(image);
+    image=(Image *) NULL;
+    return((Image *)NULL);
+  }
+
+  if (BlobIsSeekable(image) && GetBlobSize(image) < 147)
+  {
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+        "Insufficient Image Data");
+    ThrowException(exception,CorruptImageError,InsufficientImageDataInFile,image->filename);
+    DestroyImageList(image);
+    image=(Image *) NULL;
+    return((Image *)NULL);
+  }
+
   /*
     Allocate a MngInfo structure.
   */
-  have_mng_structure=False;
+  have_mng_structure=MagickFalse;
   mng_info=MagickAllocateMemory(MngInfo *,sizeof(MngInfo));
   if (mng_info == (MngInfo *) NULL)
-    ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
+  {
+    (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+        "Memory Allocation Failed");
+    ThrowException(exception,ResourceLimitError,MemoryAllocationFailed,image->filename);
+    DestroyImageList(image);
+    image=(Image *) NULL;
+    return((Image *)NULL);
+  }
   /*
     Initialize members of the MngInfo structure.
   */
   (void) memset(mng_info,0,sizeof(MngInfo));
-  have_mng_structure=True;
+  have_mng_structure=MagickTrue;
 
   mng_info->image=image;
   image=ReadOneJNGImage(mng_info,image_info,exception);
-  MngInfoFreeStruct(mng_info,&have_mng_structure);
-  if (image == (Image *) NULL)
+  if (image == (Image *) NULL || image->columns == 0 || image->rows == 0)
     {
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "exit ReadJNGImage() with error");
-      return((Image *) NULL);
+            "exit ReadJNGImage() with error");
+      if (image != (Image *) NULL)
+        {
+          DestroyImageList(image);
+          image=(Image *) NULL;
+        }
+      if (mng_info->image != (Image *) NULL)
+        {
+          DestroyImageList(mng_info->image);
+          mng_info->image=(Image *) NULL;
+        }
+      MngInfoFreeStruct(mng_info,&have_mng_structure);
+      return((Image *)NULL);
     }
+
   CloseBlob(image);
-  if (image->columns == 0 || image->rows == 0)
-    {
-      DestroyImageList(image);
-      if (logging)
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "exit ReadJNGImage() with error");
-      return((Image *) NULL);
-    }
+  MngInfoFreeStruct(mng_info,&have_mng_structure);
+
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),"exit ReadJNGImage()");
   return (image);
 }
 #endif
 
-static Image *ReadMNGImage(const ImageInfo *image_info,ExceptionInfo *exception)
+static Image *ReadMNGImage(const ImageInfo *image_info,
+                           ExceptionInfo *exception)
 {
   char
     page_geometry[MaxTextExtent];
@@ -3675,9 +3958,6 @@ static Image *ReadMNGImage(const ImageIn
     mng_background_color;
 #endif
 
-  register unsigned char
-    *p;
-
   register long
     i;
 
@@ -3686,7 +3966,7 @@ static Image *ReadMNGImage(const ImageIn
 
   short
     loop_level,
-    loops_active;
+    loops_active = 0;
 
   volatile short
     skipping_loop;
@@ -3734,21 +4014,6 @@ static Image *ReadMNGImage(const ImageIn
   default_fb.right=0;
 
   /*
-    Set image_info->type=OptimizeType (new in version 5.4.0) to get the
-    following optimizations:
-
-    o  16-bit depth is reduced to 8 if all pixels contain samples whose
-    high byte and low byte are identical.
-    o  Opaque matte channel is removed.
-    o  If matte channel is present but only one transparent color is
-    present, RGB+tRNS is written instead of RGBA
-    o  Grayscale images are reduced to 1, 2, or 4 bit depth if
-    this can be done without loss.
-    o  Palette is sorted to remove unused entries and to put a
-    transparent color first, if PNG_SORT_PALETTE is also defined.
-  */
-
-  /*
     Open image file.
   */
   assert(image_info != (const ImageInfo *) NULL);
@@ -3759,11 +4024,11 @@ static Image *ReadMNGImage(const ImageIn
   image=AllocateImage(image_info);
   mng_info=(MngInfo *) NULL;
   status=OpenBlob(image_info,image,ReadBinaryBlobMode,exception);
-  if (status == False)
+  if (status == MagickFalse)
     ThrowReaderException(FileOpenError,UnableToOpenFile,image);
-  first_mng_object=False;
+  first_mng_object=MagickFalse;
   skipping_loop=(-1);
-  have_mng_structure=False;
+  have_mng_structure=MagickFalse;
   /*
     Allocate a MngInfo structure.
   */
@@ -3775,10 +4040,7 @@ static Image *ReadMNGImage(const ImageIn
   */
   (void) memset(mng_info,0,sizeof(MngInfo));
   mng_info->image=image;
-  have_mng_structure=True;
-#if (QuantumDepth == 16)
-  mng_info->optimize=image_info->type == OptimizeType;
-#endif
+  have_mng_structure=MagickTrue;
 
   if (LocaleCompare(image_info->magick,"MNG") == 0)
     {
@@ -3790,10 +4052,10 @@ static Image *ReadMNGImage(const ImageIn
       */
       (void) ReadBlob(image,8,magic_number);
       if (memcmp(magic_number,"\212MNG\r\n\032\n",8) != 0)
-      {
-        MngInfoFreeStruct(mng_info,&have_mng_structure);
-        ThrowReaderException(CorruptImageError,ImproperImageHeader,image);
-      }
+        {
+          MngInfoFreeStruct(mng_info,&have_mng_structure);
+          ThrowReaderException(CorruptImageError,ImproperImageHeader,image);
+        }
       /*
         Initialize some nonzero members of the MngInfo structure.
       */
@@ -3802,12 +4064,12 @@ static Image *ReadMNGImage(const ImageIn
           mng_info->object_clip[i].right=PNG_MAX_UINT;
           mng_info->object_clip[i].bottom=PNG_MAX_UINT;
         }
-      mng_info->exists[0]=True;
+      mng_info->exists[0]=MagickTrue;
     }
-  first_mng_object=True;
+  first_mng_object=MagickTrue;
   mng_type=0;
 #ifdef MNG_INSERT_LAYERS
-  insert_layers=False;  /* should be False when converting or mogrifying */
+  insert_layers=MagickFalse;  /* should be False if converting or mogrifying */
 #endif
   default_frame_delay=0;
   default_frame_timeout=0;
@@ -3815,11 +4077,11 @@ static Image *ReadMNGImage(const ImageIn
   final_delay=1;
   mng_info->ticks_per_second=100;
   object_id=0;
-  skip_to_iend=False;
-  term_chunk_found=False;
+  skip_to_iend=MagickFalse;
+  term_chunk_found=MagickFalse;
   mng_info->framing_mode=1;
 #ifdef MNG_INSERT_LAYERS
-  mandatory_back=False;
+  mandatory_back=MagickFalse;
 #endif
 #ifdef MNG_INSERT_LAYERS
   mng_background_color=image->background_color;
@@ -3831,31 +4093,41 @@ static Image *ReadMNGImage(const ImageIn
 
       if (LocaleCompare(image_info->magick,"MNG") == 0)
         {
+          register unsigned char
+            *p = 0;
+
           unsigned char
-            *chunk;
+            *chunk = NULL;
 
           /*
             Read a new chunk.
           */
           type[0]='\0';
           (void) strcat(type,"errr");
-          length=ReadBlobMSBLong(image);
+          length=(size_t) ReadBlobMSBLong(image);
           count=ReadBlob(image,4,type);
+          if (count < 4)
+            {
+              if (logging)
+                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                      "  Reading MNG chunk, count: %"
+                                      "lu",
+                                      count);
+              MngInfoFreeStruct(mng_info,&have_mng_structure);
+              ThrowReaderException(CorruptImageError,CorruptImage,image);
+            }
 
           if (logging)
             (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "  Reading MNG chunk type %c%c%c%c, length: %lu",
+                                  "  Reading MNG chunk type %c%c%c%c,"
+                                  " length: %lu",
                                   type[0],type[1],type[2],type[3],length);
 
           if (length > PNG_MAX_UINT)
-            status=False;
-          if (count == 0)
-          {
-            MngInfoFreeStruct(mng_info,&have_mng_structure);
-            ThrowReaderException(CorruptImageError,CorruptImage,image);
-          }
-          p=NULL;
-          chunk=(unsigned char *) NULL;
+            {
+              MngInfoFreeStruct(mng_info,&have_mng_structure);
+              ThrowReaderException(CorruptImageError,CorruptImage,image);
+            }
           if (length)
             {
               chunk=MagickAllocateMemory(unsigned char *,length);
@@ -3865,8 +4137,12 @@ static Image *ReadMNGImage(const ImageIn
                 ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,
                                      image);
               }
-              for (i=0; i < (long) length; i++)
-                chunk[i]=ReadBlobByte(image);
+              if (ReadBlob(image,length,chunk) < length)
+                {
+                  MagickFreeMemory(chunk);
+                  MngInfoFreeStruct(mng_info,&have_mng_structure);
+                  ThrowReaderException(CorruptImageError,CorruptImage,image);
+                }
               p=chunk;
             }
           (void) ReadBlobMSBLong(image);  /* read crc word */
@@ -3874,35 +4150,32 @@ static Image *ReadMNGImage(const ImageIn
 #if !defined(JNG_SUPPORTED)
           if (!memcmp(type,mng_JHDR,4))
             {
-              skip_to_iend=True;
+              skip_to_iend=MagickTrue;
               if (!mng_info->jhdr_warning)
-              {
-                MngInfoFreeStruct(mng_info,&have_mng_structure);
                 (void) ThrowException(&image->exception,CoderError,
-                                      JNGCompressionNotSupported,image->filename);
-              }
+                                      JNGCompressionNotSupported,
+                                      image->filename);
               mng_info->jhdr_warning++;
             }
 #endif
           if (!memcmp(type,mng_DHDR,4))
             {
-              skip_to_iend=True;
+              skip_to_iend=MagickTrue;
               if (!mng_info->dhdr_warning)
-              {
-                MngInfoFreeStruct(mng_info,&have_mng_structure);
                 (void) ThrowException(&image->exception,CoderError,
                                       DeltaPNGNotSupported,image->filename);
-              }
               mng_info->dhdr_warning++;
             }
           if (!memcmp(type,mng_MEND,4))
-            break;
+            {
+              MagickFreeMemory(chunk);
+              break;
+            }
           if (skip_to_iend)
             {
               if (!memcmp(type,mng_IEND,4))
-                skip_to_iend=False;
-              if (length)
-                MagickFreeMemory(chunk);
+                skip_to_iend=MagickFalse;
+              MagickFreeMemory(chunk);
               if (logging)
                 (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                                       "  Skip to IEND.");
@@ -3910,17 +4183,44 @@ static Image *ReadMNGImage(const ImageIn
             }
           if (!memcmp(type,mng_MHDR,4))
             {
-              mng_info->mng_width=(unsigned long) ((p[0] << 24) | (p[1] << 16) |
-                                                   (p[2] << 8) | p[3]);
-              mng_info->mng_height=(unsigned long) ((p[4] << 24) | (p[5] << 16) |
-                                                    (p[6] << 8) | p[7]);
+              if (length < 16)
+                {
+                  MagickFreeMemory(chunk);
+                  MngInfoFreeStruct(mng_info,&have_mng_structure);
+                  ThrowReaderException(CorruptImageError,CorruptImage,image);
+                }
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+              /* To quiet a Coverity complaint */
+              AcquireSemaphoreInfo(&png_semaphore);
+#endif
+              mng_info->mng_width=(unsigned long) mng_get_long(p);
+              mng_info->mng_height=(unsigned long) mng_get_long(&p[4]);
               if (logging)
                 {
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "  MNG width: %lu",mng_info->mng_width);
+                                        "  MNG width: %lu",
+                                        mng_info->mng_width);
                   (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                        "  MNG height: %lu",mng_info->mng_height);
+                                        "  MNG height: %lu",
+                                        mng_info->mng_height);
                 }
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+               LiberateSemaphoreInfo(&png_semaphore);
+#endif
+              if ((long) mng_info->mng_width >
+                  65535 ||
+                  (long) mng_info->mng_height >
+                  65535)
+                {
+                  (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                      "   MNG width or height too large: %lu, %lu",
+                      mng_info->mng_width,mng_info->mng_height);
+                  MagickFreeMemory(chunk);
+                  MngInfoFreeStruct(mng_info,&have_mng_structure);
+                  ThrowReaderException(CorruptImageError,ImproperImageHeader,
+                      image);
+                }
+
               p+=8;
               mng_info->ticks_per_second=mng_get_long(p);
               if (mng_info->ticks_per_second == 0)
@@ -3929,7 +4229,7 @@ static Image *ReadMNGImage(const ImageIn
                 default_frame_delay=100/mng_info->ticks_per_second;
               frame_delay=default_frame_delay;
               simplicity=0;
-              if (length > 16)
+              if (length >= 28)
                 {
                   p+=16;
                   simplicity=mng_get_long(p);
@@ -3946,7 +4246,7 @@ static Image *ReadMNGImage(const ImageIn
                 mng_type=3; /* VLC */
 #ifdef MNG_INSERT_LAYERS
               if (mng_type != 3 && !image_info->ping)
-                insert_layers=True;
+                insert_layers=MagickTrue;
 #endif
               if (GetPixels(image) != (PixelPacket *) NULL)
                 {
@@ -3967,6 +4267,7 @@ static Image *ReadMNGImage(const ImageIn
                       "  MNG width or height is too large: %lu, %lu",
                       mng_info->mng_width,mng_info->mng_height);
                   MagickFreeMemory(chunk);
+                  MngInfoFreeStruct(mng_info,&have_mng_structure);
                   ThrowReaderException(CorruptImageError,
                      ImproperImageHeader,image);
                 }
@@ -3977,7 +4278,15 @@ static Image *ReadMNGImage(const ImageIn
               mng_info->frame.right=(long) mng_info->mng_width;
               mng_info->frame.top=0;
               mng_info->frame.bottom=(long) mng_info->mng_height;
+
+              /* To quiet a Coverity complaint */
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+              AcquireSemaphoreInfo(&png_semaphore);              
+#endif
               mng_info->clip=default_fb=previous_fb=mng_info->frame;
+#if defined(PNG_SETJMP_NOT_THREAD_SAFE)
+              LiberateSemaphoreInfo(&png_semaphore);
+#endif
               for (i=0; i < MNG_MAX_OBJECTS; i++)
                 mng_info->object_clip[i]=mng_info->frame;
               MagickFreeMemory(chunk);
